package eu.eudat.commons.types.referencetype;

import eu.eudat.commons.enums.ReferenceTypeSourceType;
import eu.eudat.service.remotefetcher.config.entities.SourceBaseConfiguration;
import jakarta.xml.bind.annotation.XmlElement;
import jakarta.xml.bind.annotation.XmlElementWrapper;

import java.util.List;
import java.util.UUID;

public abstract class ReferenceTypeSourceBaseConfigurationEntity implements SourceBaseConfiguration {

    private String key;

    private String label;

    private Integer ordinal;
    private ReferenceTypeSourceType type;

    private List<UUID> referenceTypeDependencyIds;
    public ReferenceTypeSourceType getType() {
        return type;
    }

    public String getKey() {
        return key;
    }

    @XmlElement(name = "key")
    public void setKey(String key) {
        this.key = key;
    }

    public String getLabel() {
        return label;
    }

    @XmlElement(name = "label")
    public void setLabel(String label) {
        this.label = label;
    }

    public Integer getOrdinal() {
        return ordinal;
    }

    @XmlElement(name = "ordinal")
    public void setOrdinal(Integer ordinal) {
        this.ordinal = ordinal;
    }

    @XmlElement(name = "type")
    public void setType(ReferenceTypeSourceType type) {
        this.type = type;
    }

    public List<UUID> getReferenceTypeDependencyIds() {
        return referenceTypeDependencyIds;
    }

    @XmlElementWrapper
    @XmlElement(name = "referenceTypeDependencyIds")
    public void setReferenceTypeDependencyIds(List<UUID> referenceTypeDependencyIds) {
        this.referenceTypeDependencyIds = referenceTypeDependencyIds;
    }
}
